package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.TunnelConstructiveElement;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

import java.util.List;

public class AllTunnelConstructiveElementsNode extends Renderable{

    private final List<TunnelConstructiveElement> constructiveElements;

    public AllTunnelConstructiveElementsNode(List<TunnelConstructiveElement> constructiveElements) {
        this.constructiveElements = constructiveElements;
    }

    @Override
    public String getText() {
        return "Constructive Elements";
    }

    @Override
    public void visit(Renderer renderer) {
        renderer.clearCurrentRender();
    }

    @Override
    public void refreshTextColor() {
        boolean isValidated = false;
        for (TunnelConstructiveElement bce : constructiveElements) {
            if (bce.isValidated()) {
                isValidated = true;
            }
            if (bce.containsAnyError()) {
                setStatus(CheckStatus.ERROR);
                return;
            }
        }
        if (isValidated) {
            setStatus(CheckStatus.OK);
        } else {
            setStatus(CheckStatus.NOT_CHECKED);
        }
    }

}
